/******************************************************************************
*
* Copyright (C) 2018 Xilinx, Inc.  All rights reserved.
*
* Permission is hereby granted, free of charge, to any person obtaining a copy
* of this software and associated documentation files (the "Software"), to deal
* in the Software without restriction, including without limitation the rights
* to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
* copies of the Software, and to permit persons to whom the Software is
* furnished to do so, subject to the following conditions:
*
* The above copyright notice and this permission notice shall be included in
* all copies or substantial portions of the Software.
*
* THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
* IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
* FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
* THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
* LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
* OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
* THE SOFTWARE.
*
*
*
******************************************************************************/

#include "xpm_pin.h"

static XPm_PinNode *PmMioPins[XPM_NODEIDX_STMIC_MAX];
static u16 PmNumPins;

struct PmPinGroup {
	u16 GroupCount;
	u16 *GroupList;
};

struct PmPinGroup PmPinGroups[XPM_NODEIDX_STMIC_MAX] = {
	[XPM_NODEIDX_STMIC_LMIO_0] = {
		.GroupCount = 17,
		.GroupList = ((u16 []) {
			RESERVED_GRP,
			PIN_GRP_GEM0_0,
			RESERVED_GRP,
			RESERVED_GRP,
			PIN_GRP_EMIO0_0,
			RESERVED_GRP,
			PIN_GRP_UART0_0,
			PIN_GRP_GPIO2_0,
			RESERVED_GRP,
			RESERVED_GRP,
			PIN_GRP_SPI0_0,
			RESERVED_GRP,
			PIN_GRP_CAN1_0,
			PIN_GRP_I2C1_0,
			PIN_GRP_TTC3_0_CLK,
			PIN_GRP_WWDT0_0,
			PIN_GRP_SYSMON_I2C0_0,
		}),
	},
	[XPM_NODEIDX_STMIC_LMIO_1] = {
		.GroupCount = 17,
		.GroupList = ((u16 []) {
			RESERVED_GRP,
			PIN_GRP_GEM0_0,
			RESERVED_GRP,
			RESERVED_GRP,
			PIN_GRP_EMIO0_1,
			RESERVED_GRP,
			PIN_GRP_UART0_0,
			PIN_GRP_GPIO2_1,
			RESERVED_GRP,
			RESERVED_GRP,
			PIN_GRP_SPI0_0_SS1,
			RESERVED_GRP,
			PIN_GRP_CAN1_0,
			PIN_GRP_I2C1_0,
			PIN_GRP_TTC3_0_WAV,
			PIN_GRP_WWDT0_0,
			PIN_GRP_SYSMON_I2C0_0,
		}),
	},
	[XPM_NODEIDX_STMIC_LMIO_2] = {
		.GroupCount = 17,
		.GroupList = ((u16 []) {
			RESERVED_GRP,
			PIN_GRP_GEM0_0,
			RESERVED_GRP,
			PIN_GRP_TRACE0_0,
			PIN_GRP_EMIO0_2,
			RESERVED_GRP,
			PIN_GRP_UART0_0_CTRL,
			PIN_GRP_GPIO2_2,
			RESERVED_GRP,
			RESERVED_GRP,
			PIN_GRP_SPI0_0_SS2,
			RESERVED_GRP,
			PIN_GRP_CAN0_0,
			PIN_GRP_I2C0_0,
			PIN_GRP_TTC2_0_CLK,
			PIN_GRP_WWDT0_0,
			PIN_GRP_SYSMON_I2C0_0_ALERT,
		}),
	},
	[XPM_NODEIDX_STMIC_LMIO_3] = {
		.GroupCount = 17,
		.GroupList = ((u16 []) {
			RESERVED_GRP,
			PIN_GRP_GEM0_0,
			RESERVED_GRP,
			PIN_GRP_TRACE0_0,
			PIN_GRP_EMIO0_3,
			RESERVED_GRP,
			PIN_GRP_UART0_0_CTRL,
			PIN_GRP_GPIO2_3,
			RESERVED_GRP,
			RESERVED_GRP,
			PIN_GRP_SPI0_0_SS0,
			RESERVED_GRP,
			PIN_GRP_CAN0_0,
			PIN_GRP_I2C0_0,
			PIN_GRP_TTC2_0_WAV,
			PIN_GRP_WWDT0_0,
			RESERVED_GRP,
		}),
	},
	[XPM_NODEIDX_STMIC_LMIO_4] = {
		.GroupCount = 17,
		.GroupList = ((u16 []) {
			RESERVED_GRP,
			PIN_GRP_GEM0_0,
			RESERVED_GRP,
			PIN_GRP_TRACE0_0,
			PIN_GRP_EMIO0_4,
			RESERVED_GRP,
			PIN_GRP_UART1_0,
			PIN_GRP_GPIO2_4,
			RESERVED_GRP,
			RESERVED_GRP,
			PIN_GRP_SPI0_0,
			RESERVED_GRP,
			PIN_GRP_CAN1_1,
			PIN_GRP_I2C1_1,
			PIN_GRP_TTC1_0_CLK,
			PIN_GRP_WWDT0_0,
			PIN_GRP_SYSMON_I2C0_1,
		}),
	},
	[XPM_NODEIDX_STMIC_LMIO_5] = {
		.GroupCount = 17,
		.GroupList = ((u16 []) {
			RESERVED_GRP,
			PIN_GRP_GEM0_0,
			RESERVED_GRP,
			PIN_GRP_TRACE0_0,
			PIN_GRP_EMIO0_5,
			RESERVED_GRP,
			PIN_GRP_UART1_0,
			PIN_GRP_GPIO2_5,
			RESERVED_GRP,
			RESERVED_GRP,
			PIN_GRP_SPI0_0,
			RESERVED_GRP,
			PIN_GRP_CAN1_1,
			PIN_GRP_I2C1_1,
			PIN_GRP_TTC1_0_WAV,
			PIN_GRP_WWDT0_0,
			PIN_GRP_SYSMON_I2C0_1,
		}),
	},
	[XPM_NODEIDX_STMIC_LMIO_6] = {
		.GroupCount = 17,
		.GroupList = ((u16 []) {
			RESERVED_GRP,
			PIN_GRP_GEM0_0,
			RESERVED_GRP,
			PIN_GRP_TRACE0_0_CLK,
			PIN_GRP_EMIO0_6,
			RESERVED_GRP,
			PIN_GRP_UART1_0_CTRL,
			PIN_GRP_GPIO2_6,
			RESERVED_GRP,
			RESERVED_GRP,
			PIN_GRP_SPI1_0,
			RESERVED_GRP,
			PIN_GRP_CAN0_1,
			PIN_GRP_I2C0_1,
			PIN_GRP_TTC0_0_CLK,
			PIN_GRP_WWDT1_0,
			PIN_GRP_SYSMON_I2C0_1_ALERT,
		}),
	},
	[XPM_NODEIDX_STMIC_LMIO_7] = {
		.GroupCount = 17,
		.GroupList = ((u16 []) {
			RESERVED_GRP,
			PIN_GRP_GEM0_0,
			RESERVED_GRP,
			PIN_GRP_TRACE0_0,
			PIN_GRP_EMIO0_7,
			RESERVED_GRP,
			PIN_GRP_UART1_0_CTRL,
			PIN_GRP_GPIO2_7,
			RESERVED_GRP,
			RESERVED_GRP,
			PIN_GRP_SPI1_0_SS0,
			RESERVED_GRP,
			PIN_GRP_CAN0_1,
			PIN_GRP_I2C0_1,
			PIN_GRP_TTC0_0_WAV,
			PIN_GRP_WWDT1_0,
			RESERVED_GRP,
		}),
	},
	[XPM_NODEIDX_STMIC_LMIO_8] = {
		.GroupCount = 17,
		.GroupList = ((u16 []) {
			RESERVED_GRP,
			PIN_GRP_GEM0_0,
			RESERVED_GRP,
			PIN_GRP_TRACE0_0,
			PIN_GRP_EMIO0_8,
			RESERVED_GRP,
			PIN_GRP_UART0_1,
			PIN_GRP_GPIO2_8,
			RESERVED_GRP,
			RESERVED_GRP,
			PIN_GRP_SPI1_0_SS1,
			RESERVED_GRP,
			PIN_GRP_CAN1_2,
			PIN_GRP_I2C1_2,
			PIN_GRP_TTC3_1_CLK,
			PIN_GRP_WWDT1_0,
			RESERVED_GRP,
		}),
	},
	[XPM_NODEIDX_STMIC_LMIO_9] = {
		.GroupCount = 17,
		.GroupList = ((u16 []) {
			RESERVED_GRP,
			PIN_GRP_GEM0_0,
			RESERVED_GRP,
			PIN_GRP_TRACE0_0,
			PIN_GRP_EMIO0_9,
			RESERVED_GRP,
			PIN_GRP_UART0_1,
			PIN_GRP_GPIO2_9,
			RESERVED_GRP,
			RESERVED_GRP,
			PIN_GRP_SPI1_0_SS2,
			RESERVED_GRP,
			PIN_GRP_CAN1_2,
			PIN_GRP_I2C1_2,
			PIN_GRP_TTC3_1_WAV,
			PIN_GRP_WWDT1_0,
			PIN_GRP_SYSMON_I2C0_2,
		}),
	},
	[XPM_NODEIDX_STMIC_LMIO_10] = {
		.GroupCount = 17,
		.GroupList = ((u16 []) {
			RESERVED_GRP,
			PIN_GRP_GEM0_0,
			RESERVED_GRP,
			PIN_GRP_TRACE0_0,
			PIN_GRP_EMIO0_10,
			RESERVED_GRP,
			PIN_GRP_UART0_1_CTRL,
			PIN_GRP_GPIO2_10,
			RESERVED_GRP,
			RESERVED_GRP,
			PIN_GRP_SPI1_0,
			RESERVED_GRP,
			PIN_GRP_CAN0_2,
			PIN_GRP_I2C0_2,
			PIN_GRP_TTC2_1_CLK,
			PIN_GRP_WWDT1_0,
			PIN_GRP_SYSMON_I2C0_2,
		}),
	},
	[XPM_NODEIDX_STMIC_LMIO_11] = {
		.GroupCount = 17,
		.GroupList = ((u16 []) {
			RESERVED_GRP,
			PIN_GRP_GEM0_0,
			RESERVED_GRP,
			PIN_GRP_TRACE0_0,
			PIN_GRP_EMIO0_11,
			RESERVED_GRP,
			PIN_GRP_UART0_1_CTRL,
			PIN_GRP_GPIO2_11,
			RESERVED_GRP,
			RESERVED_GRP,
			PIN_GRP_SPI1_0,
			RESERVED_GRP,
			PIN_GRP_CAN0_2,
			PIN_GRP_I2C0_2,
			PIN_GRP_TTC2_1_WAV,
			PIN_GRP_WWDT1_0,
			PIN_GRP_SYSMON_I2C0_2_ALERT,
		}),
	},
	[XPM_NODEIDX_STMIC_LMIO_12] = {
		.GroupCount = 17,
		.GroupList = ((u16 []) {
			RESERVED_GRP,
			PIN_GRP_GEM1_0,
			RESERVED_GRP,
			PIN_GRP_TRACE0_0,
			PIN_GRP_EMIO0_12,
			RESERVED_GRP,
			PIN_GRP_UART1_1,
			PIN_GRP_GPIO2_12,
			RESERVED_GRP,
			RESERVED_GRP,
			PIN_GRP_SPI0_1,
			RESERVED_GRP,
			PIN_GRP_CAN1_3,
			PIN_GRP_I2C1_3,
			PIN_GRP_TTC1_1_CLK,
			PIN_GRP_WWDT0_1,
			RESERVED_GRP,
		}),
	},
	[XPM_NODEIDX_STMIC_LMIO_13] = {
		.GroupCount = 17,
		.GroupList = ((u16 []) {
			RESERVED_GRP,
			PIN_GRP_GEM1_0,
			RESERVED_GRP,
			PIN_GRP_TRACE0_0,
			PIN_GRP_EMIO0_13,
			RESERVED_GRP,
			PIN_GRP_UART1_1,
			PIN_GRP_GPIO2_13,
			RESERVED_GRP,
			RESERVED_GRP,
			PIN_GRP_SPI0_1_SS0,
			RESERVED_GRP,
			PIN_GRP_CAN1_3,
			PIN_GRP_I2C1_3,
			PIN_GRP_TTC1_1_WAV,
			PIN_GRP_WWDT0_1,
			PIN_GRP_SYSMON_I2C0_3,
		}),
	},
	[XPM_NODEIDX_STMIC_LMIO_14] = {
		.GroupCount = 17,
		.GroupList = ((u16 []) {
			RESERVED_GRP,
			PIN_GRP_GEM1_0,
			RESERVED_GRP,
			RESERVED_GRP,
			PIN_GRP_EMIO0_14,
			RESERVED_GRP,
			PIN_GRP_UART1_1_CTRL,
			PIN_GRP_GPIO2_14,
			RESERVED_GRP,
			RESERVED_GRP,
			PIN_GRP_SPI0_1_SS1,
			RESERVED_GRP,
			PIN_GRP_CAN0_3,
			PIN_GRP_I2C0_3,
			PIN_GRP_TTC0_1_CLK,
			PIN_GRP_WWDT0_1,
			PIN_GRP_SYSMON_I2C0_3,
		}),
	},
	[XPM_NODEIDX_STMIC_LMIO_15] = {
		.GroupCount = 17,
		.GroupList = ((u16 []) {
			RESERVED_GRP,
			PIN_GRP_GEM1_0,
			RESERVED_GRP,
			RESERVED_GRP,
			PIN_GRP_EMIO0_15,
			RESERVED_GRP,
			PIN_GRP_UART1_1_CTRL,
			PIN_GRP_GPIO2_15,
			RESERVED_GRP,
			RESERVED_GRP,
			PIN_GRP_SPI0_1_SS2,
			RESERVED_GRP,
			PIN_GRP_CAN0_3,
			PIN_GRP_I2C0_3,
			PIN_GRP_TTC0_1_WAV,
			PIN_GRP_WWDT0_1,
			PIN_GRP_SYSMON_I2C0_3_ALERT,
		}),
	},
	[XPM_NODEIDX_STMIC_LMIO_16] = {
		.GroupCount = 17,
		.GroupList = ((u16 []) {
			RESERVED_GRP,
			PIN_GRP_GEM1_0,
			RESERVED_GRP,
			RESERVED_GRP,
			PIN_GRP_EMIO0_16,
			RESERVED_GRP,
			PIN_GRP_UART0_2,
			PIN_GRP_GPIO2_16,
			RESERVED_GRP,
			RESERVED_GRP,
			PIN_GRP_SPI0_1,
			RESERVED_GRP,
			PIN_GRP_CAN1_4,
			PIN_GRP_I2C1_4,
			PIN_GRP_TTC3_2_CLK,
			PIN_GRP_WWDT0_1,
			RESERVED_GRP,
		}),
	},
	[XPM_NODEIDX_STMIC_LMIO_17] = {
		.GroupCount = 17,
		.GroupList = ((u16 []) {
			RESERVED_GRP,
			PIN_GRP_GEM1_0,
			RESERVED_GRP,
			RESERVED_GRP,
			PIN_GRP_EMIO0_17,
			RESERVED_GRP,
			PIN_GRP_UART0_2,
			PIN_GRP_GPIO2_17,
			RESERVED_GRP,
			RESERVED_GRP,
			PIN_GRP_SPI0_1,
			RESERVED_GRP,
			PIN_GRP_CAN1_4,
			PIN_GRP_I2C1_4,
			PIN_GRP_TTC3_2_WAV,
			PIN_GRP_WWDT0_1,
			RESERVED_GRP,
		}),
	},
	[XPM_NODEIDX_STMIC_LMIO_18] = {
		.GroupCount = 17,
		.GroupList = ((u16 []) {
			RESERVED_GRP,
			PIN_GRP_GEM1_0,
			RESERVED_GRP,
			PIN_GRP_TRACE0_0,
			PIN_GRP_EMIO0_18,
			RESERVED_GRP,
			PIN_GRP_UART0_2_CTRL,
			PIN_GRP_GPIO2_18,
			RESERVED_GRP,
			RESERVED_GRP,
			PIN_GRP_SPI1_1,
			PIN_GRP_PCIE0_0,
			PIN_GRP_CAN0_4,
			PIN_GRP_I2C0_4,
			PIN_GRP_TTC2_2_CLK,
			PIN_GRP_WWDT1_1,
			PIN_GRP_SYSMON_I2C0_4,
		}),
	},
	[XPM_NODEIDX_STMIC_LMIO_19] = {
		.GroupCount = 17,
		.GroupList = ((u16 []) {
			RESERVED_GRP,
			PIN_GRP_GEM1_0,
			RESERVED_GRP,
			PIN_GRP_TRACE0_0,
			PIN_GRP_EMIO0_19,
			RESERVED_GRP,
			PIN_GRP_UART0_2_CTRL,
			PIN_GRP_GPIO2_19,
			RESERVED_GRP,
			RESERVED_GRP,
			PIN_GRP_SPI1_1_SS0,
			PIN_GRP_PCIE0_0,
			PIN_GRP_CAN0_4,
			PIN_GRP_I2C0_4,
			PIN_GRP_TTC2_2_WAV,
			PIN_GRP_WWDT1_1,
			PIN_GRP_SYSMON_I2C0_4,
		}),
	},
	[XPM_NODEIDX_STMIC_LMIO_20] = {
		.GroupCount = 17,
		.GroupList = ((u16 []) {
			RESERVED_GRP,
			PIN_GRP_GEM1_0,
			RESERVED_GRP,
			PIN_GRP_TRACE0_0,
			PIN_GRP_EMIO0_20,
			RESERVED_GRP,
			PIN_GRP_UART1_2,
			PIN_GRP_GPIO2_20,
			RESERVED_GRP,
			RESERVED_GRP,
			PIN_GRP_SPI1_1_SS1,
			RESERVED_GRP,
			PIN_GRP_CAN1_5,
			PIN_GRP_I2C1_5,
			PIN_GRP_TTC1_2_CLK,
			PIN_GRP_WWDT1_1,
			PIN_GRP_SYSMON_I2C0_4_ALERT,
		}),
	},
	[XPM_NODEIDX_STMIC_LMIO_21] = {
		.GroupCount = 17,
		.GroupList = ((u16 []) {
			RESERVED_GRP,
			PIN_GRP_GEM1_0,
			RESERVED_GRP,
			PIN_GRP_TRACE0_0,
			PIN_GRP_EMIO0_21,
			RESERVED_GRP,
			PIN_GRP_UART1_2,
			PIN_GRP_GPIO2_21,
			RESERVED_GRP,
			RESERVED_GRP,
			PIN_GRP_SPI1_1_SS2,
			RESERVED_GRP,
			PIN_GRP_CAN1_5,
			PIN_GRP_I2C1_5,
			PIN_GRP_TTC1_2_WAV,
			PIN_GRP_WWDT1_1,
			RESERVED_GRP,
		}),
	},
	[XPM_NODEIDX_STMIC_LMIO_22] = {
		.GroupCount = 17,
		.GroupList = ((u16 []) {
			RESERVED_GRP,
			PIN_GRP_GEM1_0,
			RESERVED_GRP,
			PIN_GRP_TRACE0_0,
			PIN_GRP_EMIO0_22,
			RESERVED_GRP,
			PIN_GRP_UART1_2_CTRL,
			PIN_GRP_GPIO2_22,
			RESERVED_GRP,
			RESERVED_GRP,
			PIN_GRP_SPI1_1,
			RESERVED_GRP,
			PIN_GRP_CAN0_5,
			PIN_GRP_I2C0_5,
			PIN_GRP_TTC0_2_CLK,
			PIN_GRP_WWDT1_1,
			RESERVED_GRP,
		}),
	},
	[XPM_NODEIDX_STMIC_LMIO_23] = {
		.GroupCount = 17,
		.GroupList = ((u16 []) {
			RESERVED_GRP,
			PIN_GRP_GEM1_0,
			RESERVED_GRP,
			PIN_GRP_TRACE0_0,
			PIN_GRP_EMIO0_23,
			RESERVED_GRP,
			PIN_GRP_UART1_2_CTRL,
			PIN_GRP_GPIO2_23,
			RESERVED_GRP,
			RESERVED_GRP,
			PIN_GRP_SPI1_1,
			RESERVED_GRP,
			PIN_GRP_CAN0_5,
			PIN_GRP_I2C0_5,
			PIN_GRP_TTC0_2_WAV,
			PIN_GRP_WWDT1_1,
			PIN_GRP_SYSMON_I2C0_5,
		}),
	},
	[XPM_NODEIDX_STMIC_LMIO_24] = {
		.GroupCount = 17,
		.GroupList = ((u16 []) {
			RESERVED_GRP,
			PIN_GRP_GEM_TSU0_0,
			RESERVED_GRP,
			RESERVED_GRP,
			PIN_GRP_EMIO0_24,
			RESERVED_GRP,
			RESERVED_GRP,
			PIN_GRP_GPIO2_24,
			RESERVED_GRP,
			RESERVED_GRP,
			RESERVED_GRP,
			RESERVED_GRP,
			PIN_GRP_CAN1_6,
			PIN_GRP_I2C1_6,
			PIN_GRP_MDIO0_0,
			PIN_GRP_MDIO1_0,
			PIN_GRP_SYSMON_I2C0_5,
		}),
	},
	[XPM_NODEIDX_STMIC_LMIO_25] = {
		.GroupCount = 17,
		.GroupList = ((u16 []) {
			RESERVED_GRP,
			PIN_GRP_GEM_TSU0_1,
			RESERVED_GRP,
			RESERVED_GRP,
			PIN_GRP_EMIO0_25,
			RESERVED_GRP,
			RESERVED_GRP,
			PIN_GRP_GPIO2_25,
			RESERVED_GRP,
			RESERVED_GRP,
			RESERVED_GRP,
			RESERVED_GRP,
			PIN_GRP_CAN1_6,
			PIN_GRP_I2C1_6,
			PIN_GRP_MDIO0_0,
			PIN_GRP_MDIO1_0,
			PIN_GRP_SYSMON_I2C0_5_ALERT,
		}),
	},
	[XPM_NODEIDX_STMIC_PMIO_0] = {
		.GroupCount = 27,
		.GroupList = ((u16 []) {
			PIN_GRP_SD1_0,
			PIN_GRP_OSPI0_0,
			PIN_GRP_QSPI0_0,
			PIN_GRP_TEST_CLK_0,
			RESERVED_GRP,
			PIN_GRP_EMIO0_26,
			RESERVED_GRP,
			PIN_GRP_UART0_3,
			PIN_GRP_GPIO0_0,
			PIN_GRP_SYSMON_I2C0_6,
			PIN_GRP_I2C1_7,
			PIN_GRP_SPI0_2,
			PIN_GRP_CAN0_6,
			PIN_GRP_WWDT0_2,
			PIN_GRP_TTC3_3_CLK,
			RESERVED_GRP,
			RESERVED_GRP,
			PIN_GRP_SD1_4BIT_0_0,
			PIN_GRP_SD1_4BIT_0_1,
			PIN_GRP_SD1_1BIT_0_0,
			PIN_GRP_SD1_1BIT_0_1,
			PIN_GRP_SD1_1BIT_0_2,
			PIN_GRP_SD1_1BIT_0_3,
			PIN_GRP_SD1_1BIT_0_4,
			PIN_GRP_SD1_1BIT_0_5,
			PIN_GRP_SD1_1BIT_0_6,
			PIN_GRP_SD1_1BIT_0_7,
		}),
	},
	[XPM_NODEIDX_STMIC_PMIO_1] = {
		.GroupCount = 17,
		.GroupList = ((u16 []) {
			PIN_GRP_SD1_0_WP,
			PIN_GRP_OSPI0_0,
			PIN_GRP_QSPI0_0,
			PIN_GRP_TEST_CLK_0,
			RESERVED_GRP,
			PIN_GRP_EMIO0_27,
			RESERVED_GRP,
			PIN_GRP_UART0_3,
			PIN_GRP_GPIO0_1,
			PIN_GRP_SYSMON_I2C0_6,
			PIN_GRP_I2C1_7,
			PIN_GRP_SPI0_2_SS0,
			PIN_GRP_CAN0_6,
			PIN_GRP_WWDT0_2,
			PIN_GRP_TTC3_3_WAV,
			RESERVED_GRP,
			RESERVED_GRP,
		}),
	},
	[XPM_NODEIDX_STMIC_PMIO_2] = {
		.GroupCount = 17,
		.GroupList = ((u16 []) {
			PIN_GRP_SD1_0_CD,
			PIN_GRP_OSPI0_0,
			PIN_GRP_QSPI0_0,
			PIN_GRP_TEST_CLK_0,
			RESERVED_GRP,
			PIN_GRP_EMIO0_28,
			RESERVED_GRP,
			PIN_GRP_UART0_3_CTRL,
			PIN_GRP_GPIO0_2,
			PIN_GRP_SYSMON_I2C0_6_ALERT,
			PIN_GRP_I2C0_6,
			PIN_GRP_SPI0_2_SS1,
			PIN_GRP_CAN1_7,
			PIN_GRP_WWDT0_2,
			PIN_GRP_TTC2_3_CLK,
			PIN_GRP_I2C_PMC_0,
			RESERVED_GRP,
		}),
	},
	[XPM_NODEIDX_STMIC_PMIO_3] = {
		.GroupCount = 27,
		.GroupList = ((u16 []) {
			PIN_GRP_SD1_0,
			PIN_GRP_OSPI0_0,
			PIN_GRP_QSPI0_0,
			PIN_GRP_TEST_CLK_0,
			RESERVED_GRP,
			PIN_GRP_EMIO0_29,
			RESERVED_GRP,
			PIN_GRP_UART0_3_CTRL,
			PIN_GRP_GPIO0_3,
			RESERVED_GRP,
			PIN_GRP_I2C0_6,
			PIN_GRP_SPI0_2_SS2,
			PIN_GRP_CAN1_7,
			PIN_GRP_WWDT0_2,
			PIN_GRP_TTC2_3_WAV,
			PIN_GRP_I2C_PMC_0,
			RESERVED_GRP,
			PIN_GRP_SD1_4BIT_0_0,
			PIN_GRP_SD1_4BIT_0_1,
			PIN_GRP_SD1_1BIT_0_0,
			PIN_GRP_SD1_1BIT_0_1,
			PIN_GRP_SD1_1BIT_0_2,
			PIN_GRP_SD1_1BIT_0_3,
			PIN_GRP_SD1_1BIT_0_4,
			PIN_GRP_SD1_1BIT_0_5,
			PIN_GRP_SD1_1BIT_0_6,
			PIN_GRP_SD1_1BIT_0_7,
		}),
	},
	[XPM_NODEIDX_STMIC_PMIO_4] = {
		.GroupCount = 19,
		.GroupList = ((u16 []) {
			PIN_GRP_SD1_0,
			PIN_GRP_OSPI0_0,
			PIN_GRP_QSPI0_0,
			RESERVED_GRP,
			PIN_GRP_TRACE0_1,
			PIN_GRP_EMIO0_30,
			RESERVED_GRP,
			PIN_GRP_UART1_3,
			PIN_GRP_GPIO0_4,
			PIN_GRP_SYSMON_I2C0_7,
			PIN_GRP_I2C1_8,
			PIN_GRP_SPI0_2,
			PIN_GRP_CAN0_7,
			PIN_GRP_WWDT0_2,
			PIN_GRP_TTC1_3_CLK,
			RESERVED_GRP,
			RESERVED_GRP,
			PIN_GRP_SD1_4BIT_0_0,
			PIN_GRP_SD1_1BIT_0_0,
		}),
	},
	[XPM_NODEIDX_STMIC_PMIO_5] = {
		.GroupCount = 19,
		.GroupList = ((u16 []) {
			PIN_GRP_SD1_0,
			PIN_GRP_OSPI0_0,
			PIN_GRP_QSPI0_0_SS,
			RESERVED_GRP,
			PIN_GRP_TRACE0_1,
			PIN_GRP_EMIO0_31,
			RESERVED_GRP,
			PIN_GRP_UART1_3,
			PIN_GRP_GPIO0_5,
			PIN_GRP_SYSMON_I2C0_7,
			PIN_GRP_I2C1_8,
			PIN_GRP_SPI0_2,
			PIN_GRP_CAN0_7,
			PIN_GRP_WWDT0_2,
			PIN_GRP_TTC1_3_WAV,
			RESERVED_GRP,
			RESERVED_GRP,
			PIN_GRP_SD1_4BIT_0_0,
			PIN_GRP_SD1_1BIT_0_1,
		}),
	},
	[XPM_NODEIDX_STMIC_PMIO_6] = {
		.GroupCount = 19,
		.GroupList = ((u16 []) {
			PIN_GRP_SD1_0,
			PIN_GRP_OSPI0_0,
			PIN_GRP_QSPI0_0_FBCLK,
			RESERVED_GRP,
			PIN_GRP_TRACE0_1_CLK,
			PIN_GRP_EMIO0_32,
			RESERVED_GRP,
			PIN_GRP_UART1_3_CTRL,
			PIN_GRP_GPIO0_6,
			PIN_GRP_SYSMON_I2C0_7_ALERT,
			PIN_GRP_I2C0_7,
			PIN_GRP_SPI1_2,
			PIN_GRP_CAN1_8,
			PIN_GRP_WWDT1_2,
			PIN_GRP_TTC0_3_CLK,
			PIN_GRP_I2C_PMC_1,
			RESERVED_GRP,
			PIN_GRP_SD1_4BIT_0_0,
			PIN_GRP_SD1_1BIT_0_2,
		}),
	},
	[XPM_NODEIDX_STMIC_PMIO_7] = {
		.GroupCount = 19,
		.GroupList = ((u16 []) {
			PIN_GRP_SD1_0,
			PIN_GRP_OSPI0_0,
			PIN_GRP_QSPI0_0_SS,
			RESERVED_GRP,
			PIN_GRP_TRACE0_1,
			PIN_GRP_EMIO0_33,
			RESERVED_GRP,
			PIN_GRP_UART1_3_CTRL,
			PIN_GRP_GPIO0_7,
			RESERVED_GRP,
			PIN_GRP_I2C0_7,
			PIN_GRP_SPI1_2_SS0,
			PIN_GRP_CAN1_8,
			PIN_GRP_WWDT1_2,
			PIN_GRP_TTC0_3_WAV,
			PIN_GRP_I2C_PMC_1,
			RESERVED_GRP,
			PIN_GRP_SD1_4BIT_0_0,
			PIN_GRP_SD1_1BIT_0_3,
		}),
	},
	[XPM_NODEIDX_STMIC_PMIO_8] = {
		.GroupCount = 19,
		.GroupList = ((u16 []) {
			PIN_GRP_SD1_0,
			PIN_GRP_OSPI0_0,
			PIN_GRP_QSPI0_0,
			RESERVED_GRP,
			PIN_GRP_TRACE0_1,
			PIN_GRP_EMIO0_34,
			RESERVED_GRP,
			PIN_GRP_UART0_4,
			PIN_GRP_GPIO0_8,
			RESERVED_GRP,
			PIN_GRP_I2C1_9,
			PIN_GRP_SPI1_2_SS1,
			PIN_GRP_CAN0_8,
			PIN_GRP_WWDT1_2,
			PIN_GRP_TTC3_4_CLK,
			RESERVED_GRP,
			RESERVED_GRP,
			PIN_GRP_SD1_4BIT_0_1,
			PIN_GRP_SD1_1BIT_0_4,
		}),
	},
	[XPM_NODEIDX_STMIC_PMIO_9] = {
		.GroupCount = 19,
		.GroupList = ((u16 []) {
			PIN_GRP_SD1_0,
			PIN_GRP_OSPI0_0,
			PIN_GRP_QSPI0_0,
			RESERVED_GRP,
			PIN_GRP_TRACE0_1,
			PIN_GRP_EMIO0_35,
			RESERVED_GRP,
			PIN_GRP_UART0_4,
			PIN_GRP_GPIO0_9,
			PIN_GRP_SYSMON_I2C0_8,
			PIN_GRP_I2C1_9,
			PIN_GRP_SPI1_2_SS2,
			PIN_GRP_CAN0_8,
			PIN_GRP_WWDT1_2,
			PIN_GRP_TTC3_4_WAV,
			RESERVED_GRP,
			RESERVED_GRP,
			PIN_GRP_SD1_4BIT_0_1,
			PIN_GRP_SD1_1BIT_0_5,
		}),
	},
	[XPM_NODEIDX_STMIC_PMIO_10] = {
		.GroupCount = 19,
		.GroupList = ((u16 []) {
			PIN_GRP_SD1_0,
			PIN_GRP_OSPI0_0_SS,
			PIN_GRP_QSPI0_0,
			RESERVED_GRP,
			PIN_GRP_TRACE0_1,
			PIN_GRP_EMIO0_36,
			RESERVED_GRP,
			PIN_GRP_UART0_4_CTRL,
			PIN_GRP_GPIO0_10,
			PIN_GRP_SYSMON_I2C0_8,
			PIN_GRP_I2C0_8,
			PIN_GRP_SPI1_2,
			PIN_GRP_CAN1_9,
			PIN_GRP_WWDT1_2,
			PIN_GRP_TTC2_4_CLK,
			PIN_GRP_I2C_PMC_2,
			RESERVED_GRP,
			PIN_GRP_SD1_4BIT_0_1,
			PIN_GRP_SD1_1BIT_0_6,
		}),
	},
	[XPM_NODEIDX_STMIC_PMIO_11] = {
		.GroupCount = 19,
		.GroupList = ((u16 []) {
			PIN_GRP_SD1_0,
			PIN_GRP_OSPI0_0_SS,
			PIN_GRP_QSPI0_0,
			RESERVED_GRP,
			PIN_GRP_TRACE0_1,
			PIN_GRP_EMIO0_37,
			RESERVED_GRP,
			PIN_GRP_UART0_4_CTRL,
			PIN_GRP_GPIO0_11,
			PIN_GRP_SYSMON_I2C0_8_ALERT,
			PIN_GRP_I2C0_8,
			PIN_GRP_SPI1_2,
			PIN_GRP_CAN1_9,
			PIN_GRP_WWDT1_2,
			PIN_GRP_TTC2_4_WAV,
			PIN_GRP_I2C_PMC_2,
			RESERVED_GRP,
			PIN_GRP_SD1_4BIT_0_1,
			PIN_GRP_SD1_1BIT_0_7,
		}),
	},
	[XPM_NODEIDX_STMIC_PMIO_12] = {
		.GroupCount = 17,
		.GroupList = ((u16 []) {
			PIN_GRP_SD1_0_PC,
			RESERVED_GRP,
			PIN_GRP_QSPI0_0,
			RESERVED_GRP,
			PIN_GRP_TRACE0_1,
			PIN_GRP_EMIO0_38,
			RESERVED_GRP,
			PIN_GRP_UART1_4,
			PIN_GRP_GPIO0_12,
			RESERVED_GRP,
			PIN_GRP_I2C1_10,
			PIN_GRP_SPI0_3,
			PIN_GRP_CAN0_9,
			PIN_GRP_WWDT0_3,
			PIN_GRP_TTC1_4_CLK,
			RESERVED_GRP,
			PIN_GRP_TAMPER_TRIGGER_0,
		}),
	},
	[XPM_NODEIDX_STMIC_PMIO_13] = {
		.GroupCount = 19,
		.GroupList = ((u16 []) {
			PIN_GRP_SD0_0,
			RESERVED_GRP,
			PIN_GRP_USB0_0,
			RESERVED_GRP,
			PIN_GRP_TRACE0_1,
			PIN_GRP_EMIO0_39,
			RESERVED_GRP,
			PIN_GRP_UART1_4,
			PIN_GRP_GPIO0_13,
			PIN_GRP_SYSMON_I2C0_9,
			PIN_GRP_I2C1_10,
			PIN_GRP_SPI0_3_SS0,
			PIN_GRP_CAN0_9,
			PIN_GRP_WWDT0_3,
			PIN_GRP_TTC1_4_WAV,
			RESERVED_GRP,
			PIN_GRP_TAMPER_TRIGGER_0,
			PIN_GRP_SD0_4BIT_0_0,
			PIN_GRP_SD0_1BIT_0_0,
		}),
	},
	[XPM_NODEIDX_STMIC_PMIO_14] = {
		.GroupCount = 19,
		.GroupList = ((u16 []) {
			PIN_GRP_SD0_0,
			PIN_GRP_SMAP0_0,
			PIN_GRP_USB0_0,
			RESERVED_GRP,
			PIN_GRP_TRACE0_1,
			PIN_GRP_EMIO0_40,
			PIN_GRP_TEST_SCAN_0,
			PIN_GRP_UART1_4_CTRL,
			PIN_GRP_GPIO0_14,
			PIN_GRP_SYSMON_I2C0_9,
			PIN_GRP_I2C0_9,
			PIN_GRP_SPI0_3_SS1,
			PIN_GRP_CAN1_10,
			PIN_GRP_WWDT0_3,
			PIN_GRP_TTC0_4_CLK,
			PIN_GRP_I2C_PMC_3,
			RESERVED_GRP,
			PIN_GRP_SD0_4BIT_0_0,
			PIN_GRP_SD0_1BIT_0_1,
		}),
	},
	[XPM_NODEIDX_STMIC_PMIO_15] = {
		.GroupCount = 19,
		.GroupList = ((u16 []) {
			PIN_GRP_SD0_0,
			PIN_GRP_SMAP0_0,
			PIN_GRP_USB0_0,
			RESERVED_GRP,
			PIN_GRP_TRACE0_1,
			PIN_GRP_EMIO0_41,
			PIN_GRP_TEST_SCAN_0,
			PIN_GRP_UART1_4_CTRL,
			PIN_GRP_GPIO0_15,
			PIN_GRP_SYSMON_I2C0_9_ALERT,
			PIN_GRP_I2C0_9,
			PIN_GRP_SPI0_3_SS2,
			PIN_GRP_CAN1_10,
			PIN_GRP_WWDT0_3,
			PIN_GRP_TTC0_4_WAV,
			PIN_GRP_I2C_PMC_3,
			RESERVED_GRP,
			PIN_GRP_SD0_4BIT_0_0,
			PIN_GRP_SD0_1BIT_0_2,
		}),
	},
	[XPM_NODEIDX_STMIC_PMIO_16] = {
		.GroupCount = 19,
		.GroupList = ((u16 []) {
			PIN_GRP_SD0_0,
			PIN_GRP_SMAP0_0,
			PIN_GRP_USB0_0,
			RESERVED_GRP,
			PIN_GRP_TRACE0_1,
			PIN_GRP_EMIO0_42,
			PIN_GRP_TEST_SCAN_0,
			PIN_GRP_UART0_5,
			PIN_GRP_GPIO0_16,
			RESERVED_GRP,
			PIN_GRP_I2C1_11,
			PIN_GRP_SPI0_3,
			PIN_GRP_CAN0_10,
			PIN_GRP_WWDT0_3,
			PIN_GRP_TTC3_5_CLK,
			RESERVED_GRP,
			RESERVED_GRP,
			PIN_GRP_SD0_4BIT_0_0,
			PIN_GRP_SD0_1BIT_0_3,
		}),
	},
	[XPM_NODEIDX_STMIC_PMIO_17] = {
		.GroupCount = 17,
		.GroupList = ((u16 []) {
			PIN_GRP_SD0_0_PC,
			PIN_GRP_SMAP0_0,
			PIN_GRP_USB0_0,
			RESERVED_GRP,
			PIN_GRP_TRACE0_1,
			PIN_GRP_EMIO0_43,
			PIN_GRP_TEST_SCAN_0,
			PIN_GRP_UART0_5,
			PIN_GRP_GPIO0_17,
			RESERVED_GRP,
			PIN_GRP_I2C1_11,
			PIN_GRP_SPI0_3,
			PIN_GRP_CAN0_10,
			PIN_GRP_WWDT0_3,
			PIN_GRP_TTC3_5_WAV,
			RESERVED_GRP,
			RESERVED_GRP,
		}),
	},
	[XPM_NODEIDX_STMIC_PMIO_18] = {
		.GroupCount = 27,
		.GroupList = ((u16 []) {
			PIN_GRP_SD0_0,
			PIN_GRP_SMAP0_0,
			PIN_GRP_USB0_0,
			RESERVED_GRP,
			PIN_GRP_TRACE0_1,
			PIN_GRP_EMIO0_44,
			PIN_GRP_TEST_SCAN_0,
			PIN_GRP_UART0_5_CTRL,
			PIN_GRP_GPIO0_18,
			PIN_GRP_SYSMON_I2C0_10,
			PIN_GRP_I2C0_10,
			PIN_GRP_SPI1_3,
			PIN_GRP_CAN1_11,
			PIN_GRP_WWDT1_3,
			PIN_GRP_TTC2_5_CLK,
			PIN_GRP_I2C_PMC_4,
			RESERVED_GRP,
			PIN_GRP_SD0_4BIT_0_0,
			PIN_GRP_SD0_4BIT_0_1,
			PIN_GRP_SD0_1BIT_0_0,
			PIN_GRP_SD0_1BIT_0_1,
			PIN_GRP_SD0_1BIT_0_2,
			PIN_GRP_SD0_1BIT_0_3,
			PIN_GRP_SD0_1BIT_0_4,
			PIN_GRP_SD0_1BIT_0_5,
			PIN_GRP_SD0_1BIT_0_6,
			PIN_GRP_SD0_1BIT_0_7,
		}),
	},
	[XPM_NODEIDX_STMIC_PMIO_19] = {
		.GroupCount = 19,
		.GroupList = ((u16 []) {
			PIN_GRP_SD0_0,
			PIN_GRP_SMAP0_0,
			PIN_GRP_USB0_0,
			RESERVED_GRP,
			PIN_GRP_TRACE0_1,
			PIN_GRP_EMIO0_45,
			PIN_GRP_TEST_SCAN_0,
			PIN_GRP_UART0_5_CTRL,
			PIN_GRP_GPIO0_19,
			PIN_GRP_SYSMON_I2C0_10,
			PIN_GRP_I2C0_10,
			PIN_GRP_SPI1_3_SS0,
			PIN_GRP_CAN1_11,
			PIN_GRP_WWDT1_3,
			PIN_GRP_TTC2_5_WAV,
			PIN_GRP_I2C_PMC_4,
			RESERVED_GRP,
			PIN_GRP_SD0_4BIT_0_1,
			PIN_GRP_SD0_1BIT_0_4,
		}),
	},
	[XPM_NODEIDX_STMIC_PMIO_20] = {
		.GroupCount = 19,
		.GroupList = ((u16 []) {
			PIN_GRP_SD0_0,
			PIN_GRP_SMAP0_0,
			PIN_GRP_USB0_0,
			RESERVED_GRP,
			PIN_GRP_TRACE0_1,
			PIN_GRP_EMIO0_46,
			PIN_GRP_TEST_SCAN_0,
			PIN_GRP_UART1_5,
			PIN_GRP_GPIO0_20,
			PIN_GRP_SYSMON_I2C0_10_ALERT,
			PIN_GRP_I2C1_12,
			PIN_GRP_SPI1_3_SS1,
			PIN_GRP_CAN0_11,
			PIN_GRP_WWDT1_3,
			PIN_GRP_TTC1_5_CLK,
			RESERVED_GRP,
			RESERVED_GRP,
			PIN_GRP_SD0_4BIT_0_1,
			PIN_GRP_SD0_1BIT_0_5,
		}),
	},
	[XPM_NODEIDX_STMIC_PMIO_21] = {
		.GroupCount = 19,
		.GroupList = ((u16 []) {
			PIN_GRP_SD0_0,
			PIN_GRP_SMAP0_0,
			PIN_GRP_USB0_0,
			RESERVED_GRP,
			PIN_GRP_TRACE0_1,
			PIN_GRP_EMIO0_47,
			PIN_GRP_TEST_SCAN_0,
			PIN_GRP_UART1_5,
			PIN_GRP_GPIO0_21,
			RESERVED_GRP,
			PIN_GRP_I2C1_12,
			PIN_GRP_SPI1_3_SS2,
			PIN_GRP_CAN0_11,
			PIN_GRP_WWDT1_3,
			PIN_GRP_TTC1_5_WAV,
			RESERVED_GRP,
			RESERVED_GRP,
			PIN_GRP_SD0_4BIT_0_1,
			PIN_GRP_SD0_1BIT_0_6,
		}),
	},
	[XPM_NODEIDX_STMIC_PMIO_22] = {
		.GroupCount = 19,
		.GroupList = ((u16 []) {
			PIN_GRP_SD0_0,
			PIN_GRP_SMAP0_0,
			PIN_GRP_USB0_0,
			RESERVED_GRP,
			RESERVED_GRP,
			PIN_GRP_EMIO0_48,
			PIN_GRP_TEST_SCAN_0,
			PIN_GRP_UART1_5_CTRL,
			PIN_GRP_GPIO0_22,
			RESERVED_GRP,
			PIN_GRP_I2C0_11,
			PIN_GRP_SPI1_3,
			PIN_GRP_CAN1_12,
			PIN_GRP_WWDT1_3,
			PIN_GRP_TTC0_5_CLK,
			PIN_GRP_I2C_PMC_5,
			PIN_GRP_TAMPER_TRIGGER_0,
			PIN_GRP_SD0_4BIT_0_1,
			PIN_GRP_SD0_1BIT_0_7,
		}),
	},
	[XPM_NODEIDX_STMIC_PMIO_23] = {
		.GroupCount = 27,
		.GroupList = ((u16 []) {
			PIN_GRP_SD0_0,
			PIN_GRP_SMAP0_0,
			PIN_GRP_USB0_0,
			RESERVED_GRP,
			RESERVED_GRP,
			PIN_GRP_EMIO0_49,
			PIN_GRP_TEST_SCAN_0,
			PIN_GRP_UART1_5_CTRL,
			PIN_GRP_GPIO0_23,
			PIN_GRP_SYSMON_I2C0_11,
			PIN_GRP_I2C0_11,
			PIN_GRP_SPI1_3,
			PIN_GRP_CAN1_12,
			PIN_GRP_WWDT1_3,
			PIN_GRP_TTC0_5_WAV,
			PIN_GRP_I2C_PMC_5,
			PIN_GRP_TAMPER_TRIGGER_0,
			PIN_GRP_SD0_4BIT_0_0,
			PIN_GRP_SD0_4BIT_0_1,
			PIN_GRP_SD0_1BIT_0_0,
			PIN_GRP_SD0_1BIT_0_1,
			PIN_GRP_SD0_1BIT_0_2,
			PIN_GRP_SD0_1BIT_0_3,
			PIN_GRP_SD0_1BIT_0_4,
			PIN_GRP_SD0_1BIT_0_5,
			PIN_GRP_SD0_1BIT_0_6,
			PIN_GRP_SD0_1BIT_0_7,
		}),
	},
	[XPM_NODEIDX_STMIC_PMIO_24] = {
		.GroupCount = 17,
		.GroupList = ((u16 []) {
			PIN_GRP_SD0_0_CD,
			PIN_GRP_SMAP0_0,
			PIN_GRP_USB0_0,
			RESERVED_GRP,
			RESERVED_GRP,
			PIN_GRP_EMIO0_50,
			PIN_GRP_TEST_SCAN_0,
			RESERVED_GRP,
			PIN_GRP_GPIO0_24,
			PIN_GRP_SYSMON_I2C0_11,
			RESERVED_GRP,
			RESERVED_GRP,
			RESERVED_GRP,
			RESERVED_GRP,
			RESERVED_GRP,
			RESERVED_GRP,
			PIN_GRP_PCIE0_1,
		}),
	},
	[XPM_NODEIDX_STMIC_PMIO_25] = {
		.GroupCount = 17,
		.GroupList = ((u16 []) {
			PIN_GRP_SD0_0_WP,
			PIN_GRP_SMAP0_0,
			PIN_GRP_USB0_0,
			RESERVED_GRP,
			RESERVED_GRP,
			PIN_GRP_EMIO0_51,
			PIN_GRP_TEST_SCAN_0,
			RESERVED_GRP,
			PIN_GRP_GPIO0_25,
			PIN_GRP_SYSMON_I2C0_11_ALERT,
			RESERVED_GRP,
			RESERVED_GRP,
			RESERVED_GRP,
			RESERVED_GRP,
			RESERVED_GRP,
			RESERVED_GRP,
			PIN_GRP_PCIE0_1,
		}),
	},
	[XPM_NODEIDX_STMIC_PMIO_26] = {
		.GroupCount = 27,
		.GroupList = ((u16 []) {
			PIN_GRP_SD1_1,
			RESERVED_GRP,
			PIN_GRP_GEM0_1,
			RESERVED_GRP,
			RESERVED_GRP,
			PIN_GRP_EMIO0_52,
			PIN_GRP_TEST_SCAN_0,
			PIN_GRP_UART0_6,
			PIN_GRP_GPIO1_0,
			PIN_GRP_SYSMON_I2C0_12,
			PIN_GRP_I2C0_12,
			PIN_GRP_SPI0_4,
			PIN_GRP_CAN0_12,
			PIN_GRP_WWDT0_4,
			PIN_GRP_TTC3_6_CLK,
			PIN_GRP_I2C_PMC_6,
			PIN_GRP_TAMPER_TRIGGER_0,
			PIN_GRP_SD1_4BIT_1_0,
			PIN_GRP_SD1_4BIT_1_1,
			PIN_GRP_SD1_1BIT_1_0,
			PIN_GRP_SD1_1BIT_1_1,
			PIN_GRP_SD1_1BIT_1_2,
			PIN_GRP_SD1_1BIT_1_3,
			PIN_GRP_SD1_1BIT_1_4,
			PIN_GRP_SD1_1BIT_1_5,
			PIN_GRP_SD1_1BIT_1_6,
			PIN_GRP_SD1_1BIT_1_7,
		}),
	},
	[XPM_NODEIDX_STMIC_PMIO_27] = {
		.GroupCount = 19,
		.GroupList = ((u16 []) {
			PIN_GRP_SD1_1,
			RESERVED_GRP,
			PIN_GRP_GEM0_1,
			RESERVED_GRP,
			RESERVED_GRP,
			PIN_GRP_EMIO0_53,
			PIN_GRP_TEST_SCAN_0,
			PIN_GRP_UART0_6,
			PIN_GRP_GPIO1_1,
			PIN_GRP_SYSMON_I2C0_12,
			PIN_GRP_I2C0_12,
			PIN_GRP_SPI0_4_SS0,
			PIN_GRP_CAN0_12,
			PIN_GRP_WWDT0_4,
			PIN_GRP_TTC3_6_WAV,
			PIN_GRP_I2C_PMC_6,
			RESERVED_GRP,
			PIN_GRP_SD1_4BIT_1_1,
			PIN_GRP_SD1_1BIT_1_7,
		}),
	},
	[XPM_NODEIDX_STMIC_PMIO_28] = {
		.GroupCount = 17,
		.GroupList = ((u16 []) {
			PIN_GRP_SD1_1_CD,
			PIN_GRP_SMAP0_0,
			PIN_GRP_GEM0_1,
			RESERVED_GRP,
			RESERVED_GRP,
			PIN_GRP_EMIO0_54,
			PIN_GRP_TEST_SCAN_0,
			PIN_GRP_UART0_6_CTRL,
			PIN_GRP_GPIO1_2,
			PIN_GRP_SYSMON_I2C0_12_ALERT,
			PIN_GRP_I2C1_13,
			PIN_GRP_SPI0_4_SS1,
			PIN_GRP_CAN1_13,
			PIN_GRP_WWDT0_4,
			PIN_GRP_TTC2_6_CLK,
			RESERVED_GRP,
			RESERVED_GRP,
		}),
	},
	[XPM_NODEIDX_STMIC_PMIO_29] = {
		.GroupCount = 27,
		.GroupList = ((u16 []) {
			PIN_GRP_SD1_1,
			PIN_GRP_SMAP0_0,
			PIN_GRP_GEM0_1,
			RESERVED_GRP,
			RESERVED_GRP,
			PIN_GRP_EMIO0_55,
			PIN_GRP_TEST_SCAN_0,
			PIN_GRP_UART0_6_CTRL,
			PIN_GRP_GPIO1_3,
			RESERVED_GRP,
			PIN_GRP_I2C1_13,
			PIN_GRP_SPI0_4_SS2,
			PIN_GRP_CAN1_13,
			PIN_GRP_WWDT0_4,
			PIN_GRP_TTC2_6_WAV,
			RESERVED_GRP,
			RESERVED_GRP,
			PIN_GRP_SD1_4BIT_1_0,
			PIN_GRP_SD1_4BIT_1_1,
			PIN_GRP_SD1_1BIT_1_0,
			PIN_GRP_SD1_1BIT_1_1,
			PIN_GRP_SD1_1BIT_1_2,
			PIN_GRP_SD1_1BIT_1_3,
			PIN_GRP_SD1_1BIT_1_4,
			PIN_GRP_SD1_1BIT_1_5,
			PIN_GRP_SD1_1BIT_1_6,
			PIN_GRP_SD1_1BIT_1_7,
		}),
	},
	[XPM_NODEIDX_STMIC_PMIO_30] = {
		.GroupCount = 19,
		.GroupList = ((u16 []) {
			PIN_GRP_SD1_1,
			PIN_GRP_SMAP0_0,
			PIN_GRP_GEM0_1,
			RESERVED_GRP,
			PIN_GRP_TRACE0_2,
			PIN_GRP_EMIO0_56,
			PIN_GRP_TEST_SCAN_0,
			PIN_GRP_UART1_6,
			PIN_GRP_GPIO1_4,
			PIN_GRP_SYSMON_I2C0_13,
			PIN_GRP_I2C0_13,
			PIN_GRP_SPI0_4,
			PIN_GRP_CAN0_13,
			PIN_GRP_WWDT0_4,
			PIN_GRP_TTC1_6_CLK,
			PIN_GRP_I2C_PMC_7,
			RESERVED_GRP,
			PIN_GRP_SD1_4BIT_1_0,
			PIN_GRP_SD1_1BIT_1_0,
		}),
	},
	[XPM_NODEIDX_STMIC_PMIO_31] = {
		.GroupCount = 19,
		.GroupList = ((u16 []) {
			PIN_GRP_SD1_1,
			PIN_GRP_SMAP0_0,
			PIN_GRP_GEM0_1,
			RESERVED_GRP,
			PIN_GRP_TRACE0_2,
			PIN_GRP_EMIO0_57,
			PIN_GRP_TEST_SCAN_0,
			PIN_GRP_UART1_6,
			PIN_GRP_GPIO1_5,
			PIN_GRP_SYSMON_I2C0_13,
			PIN_GRP_I2C0_13,
			PIN_GRP_SPI0_4,
			PIN_GRP_CAN0_13,
			PIN_GRP_WWDT0_4,
			PIN_GRP_TTC1_6_WAV,
			PIN_GRP_I2C_PMC_7,
			RESERVED_GRP,
			PIN_GRP_SD1_4BIT_1_0,
			PIN_GRP_SD1_1BIT_1_1,
		}),
	},
	[XPM_NODEIDX_STMIC_PMIO_32] = {
		.GroupCount = 19,
		.GroupList = ((u16 []) {
			PIN_GRP_SD1_1,
			PIN_GRP_SMAP0_0,
			PIN_GRP_GEM0_1,
			RESERVED_GRP,
			PIN_GRP_TRACE0_2_CLK,
			PIN_GRP_EMIO0_58,
			PIN_GRP_TEST_SCAN_0,
			PIN_GRP_UART1_6_CTRL,
			PIN_GRP_GPIO1_6,
			PIN_GRP_SYSMON_I2C0_13_ALERT,
			PIN_GRP_I2C1_14,
			PIN_GRP_SPI1_4,
			PIN_GRP_CAN1_14,
			PIN_GRP_WWDT1_4,
			PIN_GRP_TTC0_6_CLK,
			RESERVED_GRP,
			RESERVED_GRP,
			PIN_GRP_SD1_4BIT_1_0,
			PIN_GRP_SD1_1BIT_1_2,
		}),
	},
	[XPM_NODEIDX_STMIC_PMIO_33] = {
		.GroupCount = 19,
		.GroupList = ((u16 []) {
			PIN_GRP_SD1_1,
			PIN_GRP_SMAP0_0,
			PIN_GRP_GEM0_1,
			RESERVED_GRP,
			PIN_GRP_TRACE0_2,
			PIN_GRP_EMIO0_59,
			PIN_GRP_TEST_SCAN_0,
			PIN_GRP_UART1_6_CTRL,
			PIN_GRP_GPIO1_7,
			RESERVED_GRP,
			PIN_GRP_I2C1_14,
			PIN_GRP_SPI1_4_SS0,
			PIN_GRP_CAN1_14,
			PIN_GRP_WWDT1_4,
			PIN_GRP_TTC0_6_WAV,
			RESERVED_GRP,
			RESERVED_GRP,
			PIN_GRP_SD1_4BIT_1_0,
			PIN_GRP_SD1_1BIT_1_3,
		}),
	},
	[XPM_NODEIDX_STMIC_PMIO_34] = {
		.GroupCount = 19,
		.GroupList = ((u16 []) {
			PIN_GRP_SD1_1,
			PIN_GRP_SMAP0_0,
			PIN_GRP_GEM0_1,
			RESERVED_GRP,
			PIN_GRP_TRACE0_2,
			PIN_GRP_EMIO0_60,
			PIN_GRP_TEST_SCAN_0,
			PIN_GRP_UART0_7,
			PIN_GRP_GPIO1_8,
			RESERVED_GRP,
			PIN_GRP_I2C0_14,
			PIN_GRP_SPI1_4_SS1,
			PIN_GRP_CAN0_14,
			PIN_GRP_WWDT1_4,
			PIN_GRP_TTC3_7_CLK,
			PIN_GRP_I2C_PMC_8,
			RESERVED_GRP,
			PIN_GRP_SD1_4BIT_1_1,
			PIN_GRP_SD1_1BIT_1_4,
		}),
	},
	[XPM_NODEIDX_STMIC_PMIO_35] = {
		.GroupCount = 19,
		.GroupList = ((u16 []) {
			PIN_GRP_SD1_1,
			PIN_GRP_SMAP0_0,
			PIN_GRP_GEM0_1,
			RESERVED_GRP,
			PIN_GRP_TRACE0_2,
			PIN_GRP_EMIO0_61,
			PIN_GRP_TEST_SCAN_0,
			PIN_GRP_UART0_7,
			PIN_GRP_GPIO1_9,
			PIN_GRP_SYSMON_I2C0_14,
			PIN_GRP_I2C0_14,
			PIN_GRP_SPI1_4_SS2,
			PIN_GRP_CAN0_14,
			PIN_GRP_WWDT1_4,
			PIN_GRP_TTC3_7_WAV,
			PIN_GRP_I2C_PMC_8,
			RESERVED_GRP,
			PIN_GRP_SD1_4BIT_1_1,
			PIN_GRP_SD1_1BIT_1_5,
		}),
	},
	[XPM_NODEIDX_STMIC_PMIO_36] = {
		.GroupCount = 19,
		.GroupList = ((u16 []) {
			PIN_GRP_SD1_1,
			PIN_GRP_SMAP0_0,
			PIN_GRP_GEM0_1,
			RESERVED_GRP,
			PIN_GRP_TRACE0_2,
			PIN_GRP_EMIO0_62,
			PIN_GRP_TEST_SCAN_0,
			PIN_GRP_UART0_7_CTRL,
			PIN_GRP_GPIO1_10,
			PIN_GRP_SYSMON_I2C0_14,
			PIN_GRP_I2C1_15,
			PIN_GRP_SPI1_4,
			PIN_GRP_CAN1_15,
			PIN_GRP_WWDT1_4,
			PIN_GRP_TTC2_7_CLK,
			RESERVED_GRP,
			RESERVED_GRP,
			PIN_GRP_SD1_4BIT_1_1,
			PIN_GRP_SD1_1BIT_1_6,
		}),
	},
	[XPM_NODEIDX_STMIC_PMIO_37] = {
		.GroupCount = 17,
		.GroupList = ((u16 []) {
			PIN_GRP_SD0_1_WP,
			PIN_GRP_SMAP0_0,
			PIN_GRP_GEM0_1,
			RESERVED_GRP,
			PIN_GRP_TRACE0_2,
			PIN_GRP_EMIO0_63,
			PIN_GRP_TEST_SCAN_0,
			PIN_GRP_UART0_7_CTRL,
			PIN_GRP_GPIO1_11,
			PIN_GRP_SYSMON_I2C0_14_ALERT,
			PIN_GRP_I2C1_15,
			PIN_GRP_SPI1_4,
			PIN_GRP_CAN1_15,
			PIN_GRP_WWDT1_4,
			PIN_GRP_TTC2_7_WAV,
			RESERVED_GRP,
			PIN_GRP_TAMPER_TRIGGER_0,
		}),
	},
	[XPM_NODEIDX_STMIC_PMIO_38] = {
		.GroupCount = 27,
		.GroupList = ((u16 []) {
			PIN_GRP_SD0_1,
			PIN_GRP_SMAP0_0,
			PIN_GRP_GEM1_1,
			RESERVED_GRP,
			PIN_GRP_TRACE0_2,
			PIN_GRP_EMIO0_64,
			PIN_GRP_TEST_SCAN_0,
			PIN_GRP_UART1_7,
			PIN_GRP_GPIO1_12,
			RESERVED_GRP,
			PIN_GRP_I2C0_15,
			PIN_GRP_SPI0_5,
			PIN_GRP_CAN0_15,
			PIN_GRP_WWDT0_5,
			PIN_GRP_TTC1_7_CLK,
			PIN_GRP_I2C_PMC_9,
			PIN_GRP_PCIE0_2,
			PIN_GRP_SD0_4BIT_1_0,
			PIN_GRP_SD0_4BIT_1_1,
			PIN_GRP_SD0_1BIT_1_0,
			PIN_GRP_SD0_1BIT_1_1,
			PIN_GRP_SD0_1BIT_1_2,
			PIN_GRP_SD0_1BIT_1_3,
			PIN_GRP_SD0_1BIT_1_4,
			PIN_GRP_SD0_1BIT_1_5,
			PIN_GRP_SD0_1BIT_1_6,
			PIN_GRP_SD0_1BIT_1_7,
		}),
	},
	[XPM_NODEIDX_STMIC_PMIO_39] = {
		.GroupCount = 17,
		.GroupList = ((u16 []) {
			PIN_GRP_SD0_1_CD,
			PIN_GRP_SMAP0_0,
			PIN_GRP_GEM1_1,
			RESERVED_GRP,
			PIN_GRP_TRACE0_2,
			PIN_GRP_EMIO0_65,
			PIN_GRP_TEST_SCAN_0,
			PIN_GRP_UART1_7,
			PIN_GRP_GPIO1_13,
			PIN_GRP_SYSMON_I2C0_15,
			PIN_GRP_I2C0_15,
			PIN_GRP_SPI0_5_SS0,
			PIN_GRP_CAN0_15,
			PIN_GRP_WWDT0_5,
			PIN_GRP_TTC1_7_WAV,
			PIN_GRP_I2C_PMC_9,
			PIN_GRP_PCIE0_2,
		}),
	},
	[XPM_NODEIDX_STMIC_PMIO_40] = {
		.GroupCount = 27,
		.GroupList = ((u16 []) {
			PIN_GRP_SD0_1,
			PIN_GRP_SMAP0_0,
			PIN_GRP_GEM1_1,
			RESERVED_GRP,
			PIN_GRP_TRACE0_2,
			PIN_GRP_EMIO0_66,
			PIN_GRP_TEST_SCAN_0,
			PIN_GRP_UART1_7_CTRL,
			PIN_GRP_GPIO1_14,
			PIN_GRP_SYSMON_I2C0_15,
			PIN_GRP_I2C1_16,
			PIN_GRP_SPI0_5_SS1,
			PIN_GRP_CAN1_16,
			PIN_GRP_WWDT0_5,
			PIN_GRP_TTC0_7_CLK,
			RESERVED_GRP,
			RESERVED_GRP,
			PIN_GRP_SD0_4BIT_1_0,
			PIN_GRP_SD0_4BIT_1_1,
			PIN_GRP_SD0_1BIT_1_0,
			PIN_GRP_SD0_1BIT_1_1,
			PIN_GRP_SD0_1BIT_1_2,
			PIN_GRP_SD0_1BIT_1_3,
			PIN_GRP_SD0_1BIT_1_4,
			PIN_GRP_SD0_1BIT_1_5,
			PIN_GRP_SD0_1BIT_1_6,
			PIN_GRP_SD0_1BIT_1_7,
		}),
	},
	[XPM_NODEIDX_STMIC_PMIO_41] = {
		.GroupCount = 19,
		.GroupList = ((u16 []) {
			PIN_GRP_SD0_1,
			PIN_GRP_SMAP0_0,
			PIN_GRP_GEM1_1,
			RESERVED_GRP,
			PIN_GRP_TRACE0_2,
			PIN_GRP_EMIO0_67,
			PIN_GRP_TEST_SCAN_0,
			PIN_GRP_UART1_7_CTRL,
			PIN_GRP_GPIO1_15,
			PIN_GRP_SYSMON_I2C0_15_ALERT,
			PIN_GRP_I2C1_16,
			PIN_GRP_SPI0_5_SS2,
			PIN_GRP_CAN1_16,
			PIN_GRP_WWDT0_5,
			PIN_GRP_TTC0_7_WAV,
			RESERVED_GRP,
			RESERVED_GRP,
			PIN_GRP_SD0_4BIT_1_0,
			PIN_GRP_SD0_1BIT_1_0,
		}),
	},
	[XPM_NODEIDX_STMIC_PMIO_42] = {
		.GroupCount = 19,
		.GroupList = ((u16 []) {
			PIN_GRP_SD0_1,
			PIN_GRP_SMAP0_0,
			PIN_GRP_GEM1_1,
			RESERVED_GRP,
			PIN_GRP_TRACE0_2,
			PIN_GRP_EMIO0_68,
			PIN_GRP_TEST_SCAN_0,
			PIN_GRP_UART0_8,
			PIN_GRP_GPIO1_16,
			RESERVED_GRP,
			PIN_GRP_I2C0_16,
			PIN_GRP_SPI0_5,
			PIN_GRP_CAN0_16,
			PIN_GRP_WWDT0_5,
			PIN_GRP_TTC3_8_CLK,
			PIN_GRP_I2C_PMC_10,
			RESERVED_GRP,
			PIN_GRP_SD0_4BIT_1_0,
			PIN_GRP_SD0_1BIT_1_1,
		}),
	},
	[XPM_NODEIDX_STMIC_PMIO_43] = {
		.GroupCount = 19,
		.GroupList = ((u16 []) {
			PIN_GRP_SD0_1,
			PIN_GRP_SMAP0_0,
			PIN_GRP_GEM1_1,
			RESERVED_GRP,
			PIN_GRP_TRACE0_2,
			PIN_GRP_EMIO0_69,
			PIN_GRP_TEST_SCAN_0,
			PIN_GRP_UART0_8,
			PIN_GRP_GPIO1_17,
			RESERVED_GRP,
			PIN_GRP_I2C0_16,
			PIN_GRP_SPI0_5,
			PIN_GRP_CAN0_16,
			PIN_GRP_WWDT0_5,
			PIN_GRP_TTC3_8_WAV,
			PIN_GRP_I2C_PMC_10,
			RESERVED_GRP,
			PIN_GRP_SD0_4BIT_1_0,
			PIN_GRP_SD0_1BIT_1_2,
		}),
	},
	[XPM_NODEIDX_STMIC_PMIO_44] = {
		.GroupCount = 19,
		.GroupList = ((u16 []) {
			PIN_GRP_SD0_1,
			PIN_GRP_SMAP0_0,
			PIN_GRP_GEM1_1,
			RESERVED_GRP,
			PIN_GRP_TRACE0_2,
			PIN_GRP_EMIO0_70,
			PIN_GRP_TEST_SCAN_0,
			PIN_GRP_UART0_8_CTRL,
			PIN_GRP_GPIO1_18,
			PIN_GRP_SYSMON_I2C0_16,
			PIN_GRP_I2C1_17,
			PIN_GRP_SPI1_5,
			PIN_GRP_CAN1_17,
			PIN_GRP_WWDT1_5,
			PIN_GRP_TTC2_8_CLK,
			RESERVED_GRP,
			RESERVED_GRP,
			PIN_GRP_SD0_4BIT_1_0,
			PIN_GRP_SD0_1BIT_1_3,
		}),
	},
	[XPM_NODEIDX_STMIC_PMIO_45] = {
		.GroupCount = 19,
		.GroupList = ((u16 []) {
			PIN_GRP_SD0_1,
			PIN_GRP_SMAP0_0,
			PIN_GRP_GEM1_1,
			RESERVED_GRP,
			PIN_GRP_TRACE0_2,
			PIN_GRP_EMIO0_71,
			PIN_GRP_TEST_SCAN_0,
			PIN_GRP_UART0_8_CTRL,
			PIN_GRP_GPIO1_19,
			PIN_GRP_SYSMON_I2C0_16,
			PIN_GRP_I2C1_17,
			PIN_GRP_SPI1_5_SS0,
			PIN_GRP_CAN1_17,
			PIN_GRP_WWDT1_5,
			PIN_GRP_TTC2_8_WAV,
			RESERVED_GRP,
			RESERVED_GRP,
			PIN_GRP_SD0_4BIT_1_1,
			PIN_GRP_SD0_1BIT_1_4,
		}),
	},
	[XPM_NODEIDX_STMIC_PMIO_46] = {
		.GroupCount = 19,
		.GroupList = ((u16 []) {
			PIN_GRP_SD0_1,
			PIN_GRP_SMAP0_0,
			PIN_GRP_GEM1_1,
			RESERVED_GRP,
			PIN_GRP_TRACE0_2,
			PIN_GRP_EMIO0_72,
			PIN_GRP_TEST_SCAN_0,
			PIN_GRP_UART1_8,
			PIN_GRP_GPIO1_20,
			PIN_GRP_SYSMON_I2C0_16_ALERT,
			PIN_GRP_I2C0_17,
			PIN_GRP_SPI1_5_SS1,
			PIN_GRP_CAN0_17,
			PIN_GRP_WWDT1_5,
			PIN_GRP_TTC1_8_CLK,
			PIN_GRP_I2C_PMC_11,
			RESERVED_GRP,
			PIN_GRP_SD0_4BIT_1_1,
			PIN_GRP_SD0_1BIT_1_5,
		}),
	},
	[XPM_NODEIDX_STMIC_PMIO_47] = {
		.GroupCount = 19,
		.GroupList = ((u16 []) {
			PIN_GRP_SD0_1,
			PIN_GRP_SMAP0_0,
			PIN_GRP_GEM1_1,
			RESERVED_GRP,
			PIN_GRP_TRACE0_2,
			PIN_GRP_EMIO0_73,
			PIN_GRP_TEST_SCAN_0,
			PIN_GRP_UART1_8,
			PIN_GRP_GPIO1_21,
			RESERVED_GRP,
			PIN_GRP_I2C0_17,
			PIN_GRP_SPI1_5_SS2,
			PIN_GRP_CAN0_17,
			PIN_GRP_WWDT1_5,
			PIN_GRP_TTC1_8_WAV,
			PIN_GRP_I2C_PMC_11,
			RESERVED_GRP,
			PIN_GRP_SD0_4BIT_1_1,
			PIN_GRP_SD0_1BIT_1_6,
		}),
	},
	[XPM_NODEIDX_STMIC_PMIO_48] = {
		.GroupCount = 19,
		.GroupList = ((u16 []) {
			PIN_GRP_SD0_1,
			PIN_GRP_SMAP0_0,
			PIN_GRP_GEM1_1,
			RESERVED_GRP,
			RESERVED_GRP,
			PIN_GRP_EMIO0_74,
			PIN_GRP_TEST_SCAN_0,
			PIN_GRP_UART1_8_CTRL,
			PIN_GRP_GPIO1_22,
			RESERVED_GRP,
			PIN_GRP_I2C1_18,
			PIN_GRP_SPI1_5,
			PIN_GRP_CAN1_18,
			PIN_GRP_WWDT1_5,
			PIN_GRP_TTC0_8_CLK,
			RESERVED_GRP,
			RESERVED_GRP,
			PIN_GRP_SD0_4BIT_1_1,
			PIN_GRP_SD0_1BIT_1_7,
		}),
	},
	[XPM_NODEIDX_STMIC_PMIO_49] = {
		.GroupCount = 17,
		.GroupList = ((u16 []) {
			PIN_GRP_SD0_1_PC,
			PIN_GRP_SMAP0_0,
			PIN_GRP_GEM1_1,
			RESERVED_GRP,
			RESERVED_GRP,
			PIN_GRP_EMIO0_75,
			PIN_GRP_TEST_SCAN_0,
			PIN_GRP_UART1_8_CTRL,
			PIN_GRP_GPIO1_23,
			PIN_GRP_SYSMON_I2C0_17,
			PIN_GRP_I2C1_18,
			PIN_GRP_SPI1_5,
			PIN_GRP_CAN1_18,
			PIN_GRP_WWDT1_5,
			PIN_GRP_TTC0_8_WAV,
			RESERVED_GRP,
			RESERVED_GRP,
		}),
	},
	[XPM_NODEIDX_STMIC_PMIO_50] = {
		.GroupCount = 17,
		.GroupList = ((u16 []) {
			PIN_GRP_SD1_1_WP,
			PIN_GRP_SMAP0_0,
			PIN_GRP_GEM_TSU0_2,
			RESERVED_GRP,
			RESERVED_GRP,
			PIN_GRP_EMIO0_76,
			PIN_GRP_TEST_SCAN_0,
			RESERVED_GRP,
			PIN_GRP_GPIO1_24,
			PIN_GRP_SYSMON_I2C0_17,
			RESERVED_GRP,
			RESERVED_GRP,
			PIN_GRP_MDIO0_1,
			PIN_GRP_MDIO1_1,
			RESERVED_GRP,
			PIN_GRP_I2C_PMC_12,
			PIN_GRP_TAMPER_TRIGGER_0,
		}),
	},
	[XPM_NODEIDX_STMIC_PMIO_51] = {
		.GroupCount = 17,
		.GroupList = ((u16 []) {
			PIN_GRP_SD1_1_PC,
			PIN_GRP_SMAP0_0,
			PIN_GRP_GEM_TSU0_3,
			RESERVED_GRP,
			RESERVED_GRP,
			PIN_GRP_EMIO0_77,
			PIN_GRP_TEST_SCAN_0,
			RESERVED_GRP,
			PIN_GRP_GPIO1_25,
			PIN_GRP_SYSMON_I2C0_17_ALERT,
			RESERVED_GRP,
			RESERVED_GRP,
			PIN_GRP_MDIO0_1,
			PIN_GRP_MDIO1_1,
			RESERVED_GRP,
			PIN_GRP_I2C_PMC_12,
			PIN_GRP_TAMPER_TRIGGER_0,
		}),
	},
};

/****************************************************************************/
/**
 * @brief  This function validates PinFunction availability in given Pin.
 *
 * @param Pin		Pin Node.
 * @param PinFunc	Pin Function.
 *
 * @return 1 if function is available on given pin else 0.
 *
 ****************************************************************************/
static u8 ValidatePinFunc(XPm_PinNode *Pin, XPm_PinFunc *PinFunc)
{
	u16 FGrpIdx, PGrpIdx;
	u16 *FunGrps, *PinGrps;
	u8 IsValid = 0;

	FunGrps = PinFunc->Groups;
	PinGrps = Pin->Groups;

	for (PGrpIdx = 0; PGrpIdx < Pin->NumGroups; PGrpIdx++) {
		for (FGrpIdx = 0; FGrpIdx < PinFunc->NumGroups; FGrpIdx++) {
			if (FunGrps[FGrpIdx] == PinGrps[PGrpIdx]) {
				IsValid = 1;
				break;
			}
		}
		if (1 == IsValid) {
			break;
		}
	}

	return IsValid;
}

/****************************************************************************/
/**
 * @brief  This function initializes the XPm_PinNode data staructure.
 *
 * @param Pin		XPm_PinNode data staructure.
 * @param PinId		PinNode ID.
 * @param BaseAddress	BaseAddress of the pin.
 *
 * @return XST_SUCCESS if successful else XST_FAILURE or an error code.
 *
 ****************************************************************************/
XStatus XPmPin_Init(XPm_PinNode *Pin, u32 PinId, u32 BaseAddress)
{
	XStatus Status = XST_SUCCESS;
	u32 PinIdx;

	PinIdx = NODEINDEX(PinId);
	if (PinIdx >= XPM_NODEIDX_STMIC_MAX) {
		goto done;
	}

	Status = XPmNode_Init(&Pin->Node,
				PinId, XPM_PINSTATE_UNUSED, BaseAddress);
	if (XST_SUCCESS != Status) {
		goto done;
	}

	Pin->Groups = PmPinGroups[PinIdx].GroupList;
	Pin->NumGroups = PmPinGroups[PinIdx].GroupCount;
	Pin->PinFunc = NULL;
	Pin->SubsysId = INVALID_SUBSYSID;

	if (PinIdx <= PINS_PER_BANK) {
		Pin->Bank = 0;
	} else {
		Pin->Bank = (PinIdx - PINS_PER_BANK - 1) / PINS_PER_BANK;
	}

	Pin->BiasStatus = PINCTRL_BIAS_ENABLE;
	Pin->PullCtrl = PINCTRL_BIAS_PULL_UP;
	Pin->TriState = PINCTRL_TRI_STATE_ENABLE;

	PmMioPins[PinIdx] = Pin;
	PmNumPins++;

done:
	return Status;
}

/****************************************************************************/
/**
 * @brief  This function returns instance to XPm_PinNode based on PinId.
 *
 * @param PinId		PinNode ID.
 *
 * @return Instance of XPm_PinNode if successful else NULL.
 *
 ****************************************************************************/
XPm_PinNode *XPmPin_GetById(u32 PinId)
{
	XPm_PinNode *PinNode = NULL;
	u32 PinIndex = NODEINDEX(PinId);

	if (NODECLASS(PinId) != XPM_NODECLASS_STMIC) {
		goto done;
	} else if (NODESUBCLASS(PinId) != XPM_NODESUBCL_PIN) {
		goto done;
	} else if ((XPM_NODETYPE_LPD_MIO != NODETYPE(PinId)) &&
		   (XPM_NODETYPE_PMC_MIO != NODETYPE(PinId))) {
		goto done;
	} else if (PinIndex >= XPM_NODEIDX_STMIC_MAX) {
		goto done;
	} else {
		/* Required by MISRA */
	}

	PinNode =  PmMioPins[PinIndex];

done:
	return PinNode;
}

/****************************************************************************/
/**
 * @brief  This function sets pin function on given pin.
 *
 * @param PinId		Pin ID.
 * @param FuncId	Function ID.
 *
 * @return XST_SUCCESS if successful else XST_FAILURE or an error code.
 *
 ****************************************************************************/
XStatus XPmPin_SetPinFunction(u32 PinId, u32 FuncId)
{
	XStatus Status = XST_SUCCESS;
	XPm_PinNode *Pin;
	XPm_PinFunc *PinFunc;

	Pin = XPmPin_GetById(PinId);
	if (NULL == Pin) {
		Status = XST_INVALID_PARAM;
		goto done;
	}

	PinFunc = XPmPinFunc_GetById(FuncId);
	if ((NULL == PinFunc) || (0 == ValidatePinFunc(Pin, PinFunc))) {
		Status = XST_INVALID_PARAM;
		goto done;
	}

	if (XPM_NODETYPE_LPD_MIO == NODETYPE(PinId)) {
		PmOut32(Pin->Node.BaseAddress + PINNUM(Pin->Node.Id) * 4, PinFunc->LmioRegMask);
	} else if (XPM_NODETYPE_PMC_MIO == NODETYPE(PinId)) {
		PmOut32(Pin->Node.BaseAddress + PINNUM(Pin->Node.Id) * 4, PinFunc->PmioRegMask);
	} else {
		Status = XPM_PM_NO_ACCESS;
		goto done;
	}
	Pin->PinFunc = PinFunc;
	Pin->Node.State = XPM_PINSTATE_ASSIGNED;

done:
	return Status;
}

/****************************************************************************/
/**
 * @brief  This function returns pin function on given pin.
 *
 * @param PinId		Pin ID.
 * @param FuncId	Function ID.
 *
 * @return XST_SUCCESS if successful else XST_FAILURE or an error code.
 *
 ****************************************************************************/
XStatus XPmPin_GetPinFunction(u32 PinId, u32 *FuncId)
{
	XStatus Status = XST_FAILURE;
	XPm_PinNode *Pin;

	Pin = XPmPin_GetById(PinId);

	if (NULL == Pin) {
		Status = XST_INVALID_PARAM;
		goto done;
	} else if (NULL == Pin->PinFunc) {
		*FuncId = INVALID_FUNC_ID;
		Status = XST_SUCCESS;
	} else {
		*FuncId = Pin->PinFunc->Id;
		Status = XST_SUCCESS;
	}

done:
	return Status;
}

/****************************************************************************/
/**
 * @brief  This function sets pin configuration on given pin.
 *
 * @param PinId		Pin ID.
 * @param Param		Configuration parameter type.
 * @param Value		Configuration parameter value.
 *
 * @return XST_SUCCESS if successful else XST_FAILURE or an error code.
 *
 ****************************************************************************/
XStatus XPmPin_SetPinConfig(u32 PinId, u32 Param, u32 Value)
{
	XStatus Status = XST_SUCCESS;
	XPm_PinNode *Pin;
	u32 BitMask, BaseAddr;
	u32 RegPuAddr, RegPdAddr;

	Pin = XPmPin_GetById(PinId);

	if (NULL == Pin) {
		Status = XST_INVALID_PARAM;
		goto done;
	} else {
		/* Required by MISRA */
	}

	BitMask = 1 << (PINNUM(Pin->Node.Id) % PINS_PER_BANK);
	BaseAddr = Pin->Node.BaseAddress + ((Pin->Bank) * (BNK_OFFSET));

	switch (Param)
	{
		case PINCTRL_CONFIG_SLEW_RATE:
			if (PINCTRL_SLEW_RATE_SLOW == Value) {
				XPm_RMW32((BaseAddr + SEL_SLEW), BitMask, 0);
			} else if (PINCTRL_SLEW_RATE_FAST == Value) {
				XPm_RMW32((BaseAddr + SEL_SLEW), BitMask, BitMask);
			} else {
				Status = XST_INVALID_PARAM;
			}
			break;
		case PINCTRL_CONFIG_BIAS_STATUS:
			RegPuAddr = BaseAddr + EN_WK_PU;
			RegPdAddr = BaseAddr + EN_WK_PD;

			if ((PINCTRL_BIAS_ENABLE != Value) &&
				(PINCTRL_BIAS_DISABLE != Value)) {
				Status = XST_INVALID_PARAM;
				goto done;
			}

			if ((PINCTRL_BIAS_ENABLE == Value) &&
			    (PINCTRL_BIAS_DISABLE == Pin->BiasStatus)) {
				if (PINCTRL_BIAS_PULL_UP == Pin->PullCtrl) {
					PmRmw32(RegPuAddr, BitMask, BitMask);
				} else {
					PmRmw32(RegPdAddr, BitMask, BitMask);
				}
			} else if ((PINCTRL_BIAS_DISABLE == Value) &&
				   (PINCTRL_BIAS_ENABLE == Pin->BiasStatus)) {
				PmRmw32(RegPdAddr, BitMask, 0);
				PmRmw32(RegPuAddr, BitMask, 0);
			} else {
				/* Required by MISRA */
			}
			Pin->BiasStatus = Value;
			break;
		case PINCTRL_CONFIG_PULL_CTRL:
			RegPuAddr = BaseAddr + EN_WK_PU;
			RegPdAddr = BaseAddr + EN_WK_PD;

			if (PINCTRL_BIAS_ENABLE == Pin->BiasStatus) {
				if (PINCTRL_BIAS_PULL_UP == Value) {
					/* Disable weak pull-down */
					PmRmw32(RegPdAddr, BitMask, 0);
					/* Enable weak pull-up */
					PmRmw32(RegPuAddr, BitMask, BitMask);
				} else if (PINCTRL_BIAS_PULL_DOWN == Value) {
					/* Disable weak pull-up */
					PmRmw32(RegPuAddr, BitMask, 0);
					/* Enable weak pull-down */
					PmRmw32(RegPdAddr, BitMask, BitMask);
				} else {
					Status = XST_INVALID_PARAM;
					goto done;
				}
			}
			Pin->PullCtrl = Value;
			break;
		case PINCTRL_CONFIG_SCHMITT_CMOS:
			if (PINCTRL_INPUT_TYPE_CMOS == Value) {
				PmRmw32((BaseAddr + EN_RX_SCHMITT_HYST), BitMask, 0);
			} else if (PINCTRL_INPUT_TYPE_SCHMITT == Value) {
				PmRmw32((BaseAddr + EN_RX_SCHMITT_HYST), BitMask, BitMask);
			} else {
				Status = XST_INVALID_PARAM;
				goto done;
			}
			break;
		case PINCTRL_CONFIG_DRIVE_STRENGTH:
			if (Value >= PINCTRL_DRIVE_STRENGTH_MAX) {
				Status = XST_INVALID_PARAM;
				goto done;
			}

			if ((PINNUM(Pin->Node.Id) * SEL_DRV_WIDTH) < BITS_IN_REG) {
				Value <<= PINNUM(Pin->Node.Id);
				BitMask = SEL_DRV0_MASK(Pin->Node.Id);
				PmRmw32((BaseAddr + SEL_DRV0), BitMask, Value);
			} else {
				Value <<= (PINNUM(Pin->Node.Id) - (BITS_IN_REG / SEL_DRV_WIDTH));
				BitMask = SEL_DRV1_MASK(Pin->Node.Id);
				PmRmw32((BaseAddr + SEL_DRV1), BitMask, Value);
			}
			break;
		case PINCTRL_CONFIG_TRI_STATE:
			if (XPM_NODETYPE_LPD_MIO == NODETYPE(Pin->Node.Id)) {
				BaseAddr = Pin->Node.BaseAddress + TRI_STATE + 4;
			} else {
				BaseAddr = Pin->Node.BaseAddress + TRI_STATE + ((Pin->Bank) * 4);
			}

			if (Value == PINCTRL_TRI_STATE_ENABLE) {
				PmRmw32(BaseAddr, BitMask, BitMask);
			} else if (Value == PINCTRL_TRI_STATE_DISABLE) {
				/* Add check to make sure that domain is powered on */
				PmRmw32(BaseAddr, BitMask, 0);
			} else {
				Status = XST_INVALID_PARAM;
				goto done;
			}
			Pin->TriState = Value;
			break;
		default:
			Status = XST_INVALID_PARAM;
			break;
	}

done:
	return Status;
}

/****************************************************************************/
/**
 * @brief  This function returns pin configuration of given pin.
 *
 * @param PinId		Pin ID.
 * @param Param		Configuration parameter type.
 * @param Value		Configuration parameter value.
 *
 * @return XST_SUCCESS if successful else XST_FAILURE or an error code.
 *
 ****************************************************************************/
XStatus XPmPin_GetPinConfig(u32 PinId, u32 Param, u32 *Value)
{
	XStatus Status = XST_SUCCESS;
	XPm_PinNode *Pin;
	u32 BitMask;
	u32 Reg;
	u32 BaseAddr;

	Pin = XPmPin_GetById(PinId);

	if (NULL == Pin) {
		Status = XST_INVALID_PARAM;
		goto done;
	} else {
		/* Required by MISRA */
	}

	BitMask = 1 << (PINNUM(Pin->Node.Id) % PINS_PER_BANK);
	BaseAddr = Pin->Node.BaseAddress + ((Pin->Bank) * (BNK_OFFSET));

	switch (Param)
	{
		case PINCTRL_CONFIG_SLEW_RATE:
			PmIn32((BaseAddr + SEL_SLEW), Reg);
			if (BitMask == (Reg & BitMask)) {
				*Value = PINCTRL_SLEW_RATE_FAST;
			} else {
				*Value = PINCTRL_SLEW_RATE_SLOW;
			}
			break;
		case PINCTRL_CONFIG_BIAS_STATUS:
			*Value = Pin->BiasStatus;
			break;
		case PINCTRL_CONFIG_PULL_CTRL:
			*Value = Pin->PullCtrl;
			break;
		case PINCTRL_CONFIG_SCHMITT_CMOS:
			PmIn32((BaseAddr + EN_RX_SCHMITT_HYST), Reg);
			if (0 == (Reg & BitMask)) {
				*Value = PINCTRL_INPUT_TYPE_CMOS;
			} else {
				*Value = PINCTRL_INPUT_TYPE_SCHMITT;
			}
			break;
		case PINCTRL_CONFIG_DRIVE_STRENGTH:
			if ((PINNUM(Pin->Node.Id) * SEL_DRV_WIDTH) < BITS_IN_REG) {
				BitMask = SEL_DRV0_MASK(Pin->Node.Id);
				PmIn32((BaseAddr + SEL_DRV0), *Value);
				*Value &= BitMask;
				*Value >>= PINNUM(Pin->Node.Id);
			} else {
				BitMask = SEL_DRV1_MASK(Pin->Node.Id);
				PmIn32((BaseAddr + SEL_DRV1), *Value);
				*Value &= BitMask;
				*Value >>= (PINNUM(Pin->Node.Id) - (BITS_IN_REG / SEL_DRV_WIDTH));
			}
			break;
		case PINCTRL_CONFIG_VOLTAGE_STATUS:
			PmIn32((BaseAddr + VMODE), *Value);
			*Value &= VMODE_MASK;
			break;
		case PINCTRL_CONFIG_TRI_STATE:
			*Value = Pin->TriState;
			break;
		default:
			Status = XST_INVALID_PARAM;
			break;
	}

done:
	return Status;
}

/****************************************************************************/
/**
 * @brief  This function returns total number of pins added.
 *
 * @param NumPins	Number of pins.
 *
 * @return XST_SUCCESS.
 *
 ****************************************************************************/
XStatus XPmPin_GetNumPins(u32 *NumPins)
{
	*NumPins = PmNumPins;
	return XST_SUCCESS;
}

/****************************************************************************/
/**
 * @brief  This function returns groups present in pin based on
 *         pin ID. Index 0 returns the first 6 group IDs, index 6
 *         returns the next 6 group IDs, and so forth.
 *
 * @param PinId		Pin ID.
 * @param Index		Index of next function groups
 * @param Groups	Function groups.
 *
 * @return XST_SUCCESS if successful else XST_FAILURE or an error code.
 *
 ****************************************************************************/
XStatus XPmPin_GetPinGroups(u32 PinId, u32 Index, u16 *Groups)
{
	XStatus Status = XST_FAILURE;
	u32 i;
	u32 NumRead;
	XPm_PinNode *Pin;

	Pin = XPmPin_GetById(PinId);

	memset(Groups, END_OF_GRP, (MAX_GROUPS_PER_RES * sizeof(u16)));

	if (NULL == Pin) {
		Status = XST_INVALID_PARAM;
		goto done;
	} else {
		/* Required by MISRA */
	}

	/* Read up to 6 group IDs from Index */
	if ((Pin->NumGroups - Index) > MAX_GROUPS_PER_RES) {
		NumRead = MAX_GROUPS_PER_RES;
	} else {
		NumRead = Pin->NumGroups - Index;
	}

	for (i = 0; i < NumRead; i++) {
		Groups[i] = Pin->Groups[i + Index];
	}

	Status = XST_SUCCESS;

done:
	return Status;
}

/****************************************************************************/
/**
 * @brief  This function requests pin.
 *
 * @param SubsystemId	Subsystem ID.
 * @param PinId		Pin ID.
 *
 * @return XST_SUCCESS if successful else XST_FAILURE or an error code.
 *
 ****************************************************************************/
XStatus XPmPin_Request(const u32 SubsystemId, const u32 PinId)
{
	XStatus Status = XST_SUCCESS;
	XPm_PinNode *Pin;

	Pin = XPmPin_GetById(PinId);
	if (NULL == Pin) {
		Status = XST_INVALID_PARAM;
		goto done;
	}

	if (Pin->SubsysId != INVALID_SUBSYSID) {
		if (SubsystemId == Pin->SubsysId) {
			goto done;
		}
		Status = XPM_PM_NO_ACCESS;
		goto done;
	}

	Pin->SubsysId = SubsystemId;

done:
	return Status;
}

/****************************************************************************/
/**
 * @brief  This function releases pin.
 *
 * @param SubsystemId	Subsystem ID.
 * @param PinId		Pin ID.
 *
 * @return XST_SUCCESS if successful else XST_FAILURE or an error code.
 *
 ****************************************************************************/
XStatus XPmPin_Release(const u32 SubsystemId, const u32 PinId)
{
	XStatus Status = XST_SUCCESS;
	XPm_PinNode *Pin;

	Pin = XPmPin_GetById(PinId);
	if (NULL == Pin) {
		Status = XST_INVALID_PARAM;
		goto done;
	}

	if (SubsystemId != Pin->SubsysId) {
		Status = XST_FAILURE;
		goto done;
	}

	Pin->SubsysId = INVALID_SUBSYSID;

done:
	return Status;
}

/****************************************************************************/
/**
 * @brief  This function checks permission for given pin. If subsystem
 *	   requested this pin it returns success else error code.
 *
 * @param SubsystemId	Subsystem ID.
 * @param PinId		Pin ID.
 *
 * @return XST_SUCCESS if successful else XST_FAILURE or an error code.
 *
 ****************************************************************************/
XStatus XPmPin_CheckPerms(const u32 SubsystemId, const u32 PinId)
{
	XStatus Status = XST_SUCCESS;
	XPm_PinNode *Pin;

	Pin = XPmPin_GetById(PinId);
	if (NULL == Pin) {
		Status = XST_INVALID_PARAM;
		goto done;
	}

	if (SubsystemId != Pin->SubsysId) {
		Status = XPM_PM_NO_ACCESS;
		goto done;
	}

done:
	return Status;
}
